package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Tab;

import com.rjconsultores.ventaboletos.entidad.Conexion;
import com.rjconsultores.ventaboletos.entidad.ConexionConf;
import com.rjconsultores.ventaboletos.entidad.ConexionCtrl;
import com.rjconsultores.ventaboletos.entidad.ConexionDescuento;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaCtrl;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaExcepcionPtoVta;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaExcepcionTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaTramoCtrl;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaCombinacion;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ConexionConfService;
import com.rjconsultores.ventaboletos.service.ConexionCtrlService;
import com.rjconsultores.ventaboletos.service.ConexionDescuentoService;
import com.rjconsultores.ventaboletos.service.ConexionRutaCtrlService;
import com.rjconsultores.ventaboletos.service.ConexionRutaExcepcionPtoVtaService;
import com.rjconsultores.ventaboletos.service.ConexionRutaExcepcionTipoPtoVtaService;
import com.rjconsultores.ventaboletos.service.ConexionRutaTramoCtrlService;
import com.rjconsultores.ventaboletos.service.ConexionService;
import com.rjconsultores.ventaboletos.service.RutaCombinacionService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.vo.parada.ParadaVOConexionRuta;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexionPorRuta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexionRuta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConexionRutaRemoveSelecionada;

@Controller("gerarConexionPorRutaController")
@Scope("prototype")
public class GerarConexionPorRutaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(GerarConexionPorRutaController.class);

	@Autowired
	private ConexionService conexionService;
	@Autowired
	private ConexionCtrlService conexionCtrlService;
	@Autowired
	private ConexionConfService conexionConfService;
	@Autowired
	private ConexionRutaCtrlService conexionRutaCtrlService;
	@Autowired
	private ConexionRutaTramoCtrlService conexionRutaTramoCtrlService;
	@Autowired
	private RutaService rutaService;
	@Autowired
	private ConexionDescuentoService conexionDescuentoService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private ConexionRutaExcepcionPtoVtaService conexionRutaRestricaoPtoVtaService;
	@Autowired
	private ConexionRutaExcepcionTipoPtoVtaService conexionRutaExcepcionTipoPtoVtaService;
	@Autowired
	private RutaCombinacionService rutaCombinacionService;
	
	private List<Parada> lsOrigens;
	private List<Parada> lsDestino;
	private MyListbox localidadesOrigemlList;
	private MyListbox localidadesDestinoList;
	private MyListbox localidadesOrigenSelecionadaList;
	private MyListbox localidadesDestinoSelecionadaList;
	private Tab resultadoCombinacao;
	private Button btnSalvar;
	private Intbox txtTiempoMin;
	private Intbox txtTiempoMax;
	private MyListbox localidadesCombinadasList;
	private MyListbox localidadesComunsList;
	private MyListbox listEspCanal;
	private MyListbox listPuntoVenta;
	private MyComboboxEstandar cmbRutaOrigem;
	private MyComboboxEstandar cmbRutaDestino;
	private List<Parada> lsLocalidadesComuns;
	private Combobox cmbTipoPtovta;
	private Combobox cmbPtovta;
	private List<TipoPuntoVenta> lsTipoPtovta;
	private List<Conexion> lsConexoes;
	private Integer grupo;
	private Short secuencia;

	private List<Ruta> lsRutas;
	private HashMap<Integer, ConexionConf> conexionesConfHash;
	private List<ConexionDescuento> conexoesDescontoRemovidas;
	private Map<Integer, Parada> cacheLocalidades;
	private List<ConexionCtrl> conexoesCtrl;
	private List<ConexionRutaTramoCtrl> lsConexionRutaTramo;
	private List<ConexionRutaTramoCtrl> lsConexionExistentesRutaTramo;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		grupo = 1;
		secuencia = 1;
		conexoesDescontoRemovidas = new ArrayList<ConexionDescuento>();
		conexionesConfHash = new HashMap<Integer, ConexionConf>();
		txtTiempoMax.setConstraint("no empty");
		txtTiempoMin.setConstraint("no empty");

		lsRutas = rutaService.obtenerTodos();
		lsTipoPtovta = tipoPuntoVentaService.obtenerTodos();

		localidadesOrigenSelecionadaList.setItemRenderer(new RenderConexionRutaRemoveSelecionada(new EventListener() {

			@Override
			public void onEvent(Event arg0) throws Exception {

				Parada parada = (Parada) arg0.getTarget().getAttribute("data");
				for (Object objectParada : localidadesOrigenSelecionadaList.getListData()) {
					if (((Parada) objectParada).equals(parada)) {
						localidadesOrigenSelecionadaList.removeItem(parada);
						break;
					}
				}
			}
		}));
		localidadesDestinoSelecionadaList.setItemRenderer(new RenderConexionRutaRemoveSelecionada(new EventListener() {

			@Override
			public void onEvent(Event arg0) throws Exception {

				Parada parada = (Parada) arg0.getTarget().getAttribute("data");
				for (Object objectParada : localidadesDestinoSelecionadaList.getListData()) {
					if (((Parada) objectParada).equals(parada)) {
						localidadesDestinoSelecionadaList.removeItem(parada);
						break;
					}
				}
			}
		}));
	}


	@SuppressWarnings("unchecked")
	public void addConexao( ConexionCtrl conexionCtrl) throws InterruptedException{
		lsConexoes = new ArrayList<Conexion>();

		Integer tempoMin = txtTiempoMin.getValue();  
		Integer tempoMax = txtTiempoMax.getValue();

		secuencia = 1;
		
		LOPP_EXTERNO: for (ParadaVOConexionRuta vo : (List<ParadaVOConexionRuta> )localidadesCombinadasList.getListData()) {
			Conexion conexion = new Conexion();
			conexion.setOrigenId(vo.getParadaOrigem().getParadaId());
			conexion.setDestinoId(vo.getParadaDestino().getParadaId());
			conexion.setRutaId(vo.getRutaId());
			conexion.setActivo(true);
			conexion.setNumgrupo(grupo);
			for (ConexionRutaTramoCtrl conexionRutaTramoCtrl : lsConexionRutaTramo) {
				if(conexionRutaTramoCtrl.getOrigenId().equals(vo.getParadaOrigem().getParadaId()) && conexionRutaTramoCtrl.getDestinoId().equals(vo.getParadaDestino().getParadaId()) && secuencia == vo.getSecuencia() && vo.isValido()) {
					conexion.setConexionRutaTramoId(conexionRutaTramoCtrl.getConexionRutaTramoId());
					conexion.setNumsecuencia(secuencia);
					vo.setValido(false);
					adicionarTrecho(vo.getParadaDestino(), conexion, tempoMax, tempoMin, conexionCtrl);
				}else if(secuencia > vo.getSecuencia()) {
					continue LOPP_EXTERNO;
				}
			}
			
		}

	}

	private void adicionarTrecho(Parada destino, Conexion conexion, Integer tempoMax, Integer tempoMin, ConexionCtrl conexionCtrl) throws InterruptedException {

		criaConfiguracaoConexao(tempoMax, tempoMin, conexionCtrl);
		lsConexoes.add(conexion);
		secuencia++;

	}
	
	@SuppressWarnings("unchecked")
	private boolean validarTrechos() throws InterruptedException {
			
		Ruta rutaOrigem = (Ruta) cmbRutaOrigem.getSelectedItem().getValue();
		List<Parada> paradasOrigen = localidadesOrigenSelecionadaList.getListData();
		
		for (Parada paradaOrigem : paradasOrigen) {
			for (Parada paradaComum : lsLocalidadesComuns) {
				if (!rutaCombinacionService.busquedaRutaTramo(rutaOrigem, rutaCombinacionService.busqueda(rutaOrigem, paradaOrigem, paradaComum), Boolean.TRUE)) {
					mostraMensagem(Labels.getLabel("editarConexionController.MSG.trechoInexistente")+"  " + paradaOrigem + " - " + paradaComum);
					return false;
				}
			}
		}
		return true;
	}
	

	private void criaConfiguracaoConexao(Integer tempoMax, Integer tempoMin, ConexionCtrl conexionCtrl) {
		if (secuencia == 1) {
			ConexionConf conexionConf = new ConexionConf();
			conexionConf.setGrupo(grupo);
			conexionConf.setTiempoMax(tempoMax);
			conexionConf.setTiempoMin(tempoMin);
			conexionConf.setIndisponible(false);
			conexionConf.setActivo(true);
			conexionConf.setConexionCtrl(conexionCtrl);

			conexionesConfHash.put(grupo, conexionConf);
			txtTiempoMax.setDisabled(true);
			txtTiempoMin.setDisabled(true);
		}
	}

	public void finalizarInsercao() {
		secuencia = 1;
		grupo++;
	}

	public void onClick$btnSalvar(Event ev) throws Exception {
		
		if(!validarItensSalvar()) {
			return;
		}
		if (validarConexioneRutasExistentes()) {

			StringBuilder sb = new StringBuilder();
			for (ConexionRutaTramoCtrl conexionRutaTramoCtrl : lsConexionExistentesRutaTramo) {
				sb.append(cacheLocalidades.get(conexionRutaTramoCtrl.getOrigenId()).getDescparada() + "  - " + cacheLocalidades.get(conexionRutaTramoCtrl.getDestinoId()).getDescparada());
				sb.append("\n");				
			}
			mostraMensagem(Labels.getLabel("editarConexionPorRutaController.MSG.suscribirOBSOK")+ "\n - " + sb.toString());

			return;
		}
		
		ConexionRutaCtrl conexionRutaCtrl = new ConexionRutaCtrl();

		salvarConexionesRutaCtrl(conexionRutaCtrl);
		salvarPuntoVentasRutaCtrl(conexionRutaCtrl);
		salvarCanalVentasRutaCtrl(conexionRutaCtrl);

		for (ConexionCtrl conexionCtrl : conexoesCtrl) {

			if (conexionCtrl.getConexionctrlId() == null) {
				
				conexionCtrlService.suscribir(conexionCtrl);
			} else {
				conexionCtrlService.actualizacion(conexionCtrl);
			}
			salvarConexiones(conexionCtrl);
		}
		if(!lsConexionExistentesRutaTramo.isEmpty()) { 
			StringBuilder sb = new StringBuilder();
			for (ConexionRutaTramoCtrl conexionRutaTramoCtrl : lsConexionExistentesRutaTramo) {
				sb.append(cacheLocalidades.get(conexionRutaTramoCtrl.getOrigenId()).getDescparada() + "  - " + cacheLocalidades.get(conexionRutaTramoCtrl.getDestinoId()).getDescparada());
				sb.append("\n");
			}
			mostraMensagem(Labels.getLabel("editarConexionPorRutaController.MSG.suscribirOBSOK")+ "\n - " + sb.toString());

		}
		mostraMensagem(Labels.getLabel("editarConexionPorRutaController.MSG.suscribirOK"));

		closeWindow();
	}
	
	@SuppressWarnings("unchecked")
	private boolean validarConexioneRutasExistentes() {

		Ruta rutaOrigem = (Ruta) cmbRutaOrigem.getSelectedItem().getValue();
		Ruta rutaDestino = (Ruta) cmbRutaDestino.getSelectedItem().getValue();
		boolean conexaoExistente = false;
		lsConexionRutaTramo = new ArrayList<ConexionRutaTramoCtrl>();
		lsConexionExistentesRutaTramo = new ArrayList<ConexionRutaTramoCtrl>();
		
		for (ParadaVOConexionRuta vo : (List<ParadaVOConexionRuta>) localidadesCombinadasList.getListData()) {
			
			ConexionRutaTramoCtrl conexionRutaTramoCtrl = new ConexionRutaTramoCtrl();
			conexionRutaTramoCtrl.setOrigenId(vo.getParadaOrigem().getParadaId());
			conexionRutaTramoCtrl.setDestinoId(vo.getParadaDestino().getParadaId());
					
			conexaoExistente = conexionRutaTramoCtrlService.validarConexioneRutasExistentes(rutaOrigem.getRutaId(), rutaDestino.getRutaId(), 
					vo.getParadaOrigem().getParadaId(), vo.getParadaDestino().getParadaId(), vo.getParadaOrigemTrecho().getParadaId(),  vo.getParadaDestinoTrecho().getParadaId());
			
			if (conexaoExistente) {
				lsConexionExistentesRutaTramo.add(conexionRutaTramoCtrl);
				Iterator<ConexionCtrl> it = conexoesCtrl.iterator();
				while(it.hasNext()) {
					ConexionCtrl cc = it.next();
					if(cc.getOrigenId().equals(vo.getParadaOrigemTrecho().getParadaId()) && cc.getDestinoId().equals(vo.getParadaDestinoTrecho().getParadaId())) {
						conexoesCtrl.remove(cc);
						break;
					}					
				}
			}else {
				lsConexionRutaTramo.add(conexionRutaTramoCtrl);
			}

		}

		return lsConexionRutaTramo.isEmpty();
	}

	private void salvarConexiones(ConexionCtrl conexionCtrl) {
		
		try {
			addConexao(conexionCtrl);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		List<ConexionDescuento> conexionesDescuentos = new ArrayList<ConexionDescuento>();
		conexionesDescuentos.addAll(conexoesDescontoRemovidas);
		
		Collections.sort(lsConexoes, new Comparator<Conexion>() {

			@Override
			public int compare(Conexion o1, Conexion o2) {
				o1.getNumsecuencia().compareTo(o2.getNumsecuencia());
				return 0;
			}
		});

		for (Conexion conexion : lsConexoes) {
			conexion.setConexionctrlId(conexionCtrl.getConexionctrlId());
			conexion.setFecmodif(Calendar.getInstance().getTime());
			conexion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			conexionesDescuentos.addAll(conexion.getConexionesDescuentos());
		}

		for (ConexionDescuento conexionDescuento : conexionesDescuentos) {
			conexionDescuento.setFecModif(Calendar.getInstance().getTime());
		}

		conexionService.suscribirTodos(lsConexoes);
		conexionDescuentoService.suscribirTodos(conexionesDescuentos);
		salvarConexionesConf(conexionCtrl);
	}

	private void salvarConexionesConf(ConexionCtrl conexionCtrl) {
		for (ConexionConf conexionConf : conexionesConfHash.values()) {
			conexionConf.setConexionCtrl(conexionCtrl);
			conexionConf.setFecmodif(Calendar.getInstance().getTime());
			conexionConf.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		}
		conexionConfService.suscribirTodos(conexionesConfHash.values());
	}
	
	private void salvarConexionesRutaCtrl(ConexionRutaCtrl conecionRuta) {
						
		Ruta rutaOrigem = (Ruta) cmbRutaOrigem.getSelectedItem().getValue();
		Ruta rutaDestino = (Ruta) cmbRutaDestino.getSelectedItem().getValue();

		conecionRuta.setRutaOrigenId(rutaOrigem.getRutaId());
		conecionRuta.setRutaDestinoId(rutaDestino.getRutaId());
		
		conexionRutaCtrlService.suscribir(conecionRuta);
		salvarConexionesRutaTramoCtrl(conecionRuta);
	}
	
	private void salvarConexionesRutaTramoCtrl(ConexionRutaCtrl conecionRuta) {
		
		for (ConexionRutaTramoCtrl conexionRutaTramoCtrl : lsConexionRutaTramo) {
			conexionRutaTramoCtrl.setConexionRutaCtrl(conecionRuta);
		}
		
		conexionRutaTramoCtrlService.suscribirTodos(lsConexionRutaTramo);
	}
	
	private void salvarCanalVentasRutaCtrl(ConexionRutaCtrl conexionRutaCtrl) {
		
		@SuppressWarnings("unchecked")
		List<TipoPuntoVenta> puntoVentas = listEspCanal.getListData();
		List<ConexionRutaExcepcionTipoPtoVta> canalVentaConexionRutas = new ArrayList<ConexionRutaExcepcionTipoPtoVta>();

		for (TipoPuntoVenta vo : puntoVentas) {
			
			ConexionRutaExcepcionTipoPtoVta  conexionRutaPtoVta = new ConexionRutaExcepcionTipoPtoVta();
			conexionRutaPtoVta.setConexionRutaCtrl(conexionRutaCtrl);
			conexionRutaPtoVta.setTipoPtovta(vo);
			canalVentaConexionRutas.add(conexionRutaPtoVta);
		}
		conexionRutaExcepcionTipoPtoVtaService.suscribirTodos(canalVentaConexionRutas);
		
	}
	
	private void salvarPuntoVentasRutaCtrl(ConexionRutaCtrl conexionRutaCtrl) {
		
		@SuppressWarnings("unchecked")
		List<PuntoVenta> puntoVentas = listPuntoVenta.getListData();
		List<ConexionRutaExcepcionPtoVta> puntoVentasConexionRuta = new ArrayList<ConexionRutaExcepcionPtoVta>();

		for (PuntoVenta vo : puntoVentas) {
			
			ConexionRutaExcepcionPtoVta  conexionRutaPtoVta = new ConexionRutaExcepcionPtoVta();
			conexionRutaPtoVta.setConexionRutaCtrl(conexionRutaCtrl);
			conexionRutaPtoVta.setPuntoVenta(vo);
			puntoVentasConexionRuta.add(conexionRutaPtoVta);
		}
		conexionRutaRestricaoPtoVtaService.suscribirTodos(puntoVentasConexionRuta);
		
	}

	public void onClick$btnPesquisaPermissao(Event ev) throws InterruptedException {
		executarPesquisaLocalidadesOrigen();
	}

	public void onClick$btnPesquisaLocalidadesDestino(Event ev) throws InterruptedException {
		executarPesquisaLocalidadesDestino();
	}

	private void executarPesquisaLocalidadesOrigen() throws InterruptedException {

		if (!validarLinhaJaSelecionada()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.rutaJaSelecionada"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}

		// localidadesOrigenSelecionadaList.clear();
		localidadesCombinadasList.clear();
		localidadesComunsList.setModel(new ListModelList(new ArrayList<Parada>()));
		localidadesDestinoList.setModel(new ListModelList(new ArrayList<Parada>()));
		localidadesDestinoSelecionadaList.setModel(new ListModelList(new ArrayList<Parada>()));
		
		Set<Parada> lsParadas = new HashSet<Parada>(0);
		try {
			Ruta ruta = cmbRutaOrigem.getSelectedItem() != null ? (Ruta) cmbRutaOrigem.getSelectedItem().getValue() : null;
			if (localidadesOrigemlList.getItems() != null) {
				localidadesOrigemlList.getItems().clear();
			}
			if (ruta != null) {

				ruta = rutaService.obtenerID(ruta.getRutaId());
				if (ruta != null && ruta.getRutaCombinacionList() != null) {
					for (RutaCombinacion rc : ruta.getRutaCombinacionList()) {
						if (rc.getTramo() != null) {
							lsParadas.add(rc.getTramo().getOrigem());
							lsParadas.add(rc.getTramo().getDestino());
						}
					}
				}

				lsOrigens = new ArrayList<Parada>(lsParadas);
				localidadesOrigenSelecionadaList.setData(lsOrigens);
				localidadesOrigemlList.setData(lsOrigens);
			}

			localidadesOrigemlList.setItemRenderer(new RenderConexionRuta(new EventListener() {

				@Override
				public void onEvent(Event arg0) throws Exception {
					Parada parada = (Parada) arg0.getTarget().getAttribute("data");
					if (arg0.getTarget().getAttribute("tipo").equals(RenderConexionRuta.BOTAO_ADICIONAR_PERMISSAO)) {
						if (localidadesOrigenSelecionadaList.getListData().isEmpty()) {
							localidadesOrigenSelecionadaList.addItemNovo(parada);
						} else {
							for (Object objectParada : localidadesOrigenSelecionadaList.getListData()) {
								if (localidadesOrigenSelecionadaList.getListData().contains(parada) ||  (getLsLocalidadesComuns() != null && getLsLocalidadesComuns().contains(parada))) {
									return;
								}
								if (!((Parada) objectParada).equals(parada)) {
									localidadesOrigenSelecionadaList.addItemNovo(parada);
									break;
								}
							}
						}
						localidadesOrigemlList.removeItem(parada);
					}
				}
			}));
		} catch (Exception e) {
			log.error("", e);
		}

	}

	@SuppressWarnings("unchecked")
	private void executarPesquisaLocalidadesDestino() throws InterruptedException {
		
		if (!validarLinhaJaSelecionada()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.rutaJaSelecionada"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}

		localidadesCombinadasList.clear();

		
		Set<Parada> lsParadas = new HashSet<Parada>(0);
		try {
			Ruta ruta = cmbRutaDestino.getSelectedItem() != null ? (Ruta) cmbRutaDestino.getSelectedItem().getValue() : null;
			if (localidadesDestinoList.getItems() != null) {
				localidadesDestinoList.getItems().clear();
			}
			if (ruta != null) {

				ruta = rutaService.obtenerID(ruta.getRutaId());
				if (ruta != null && ruta.getRutaCombinacionList() != null) {
					for (RutaCombinacion rc : ruta.getRutaCombinacionList()) {
						if (rc.getTramo() != null) {
							lsParadas.add(rc.getTramo().getOrigem());
							lsParadas.add(rc.getTramo().getDestino());
						}
					}
				}

				lsDestino = new ArrayList<Parada>(lsParadas);
				localidadesDestinoSelecionadaList.setData(new ListModelList(lsDestino));
				localidadesDestinoList.setModel(new ListModelList(lsDestino));
			}

			localidadesDestinoList.setItemRenderer(new RenderConexionRuta(new EventListener() {

				@Override
				public void onEvent(Event arg0) throws Exception {
					Parada parada = (Parada) arg0.getTarget().getAttribute("data");
					if (arg0.getTarget().getAttribute("tipo").equals(RenderConexionRuta.BOTAO_ADICIONAR_PERMISSAO)) {
						if (localidadesDestinoSelecionadaList.getListData().isEmpty()) {
							localidadesDestinoSelecionadaList.addItemNovo(parada);
						} else {
							for (Object objectParada : localidadesDestinoSelecionadaList.getListData()) {
								if (localidadesDestinoSelecionadaList.getListData().contains(parada) ||   (getLsLocalidadesComuns() != null && getLsLocalidadesComuns().contains(parada))) {
									return;
								}
								if (!((Parada) objectParada).equals(parada)) {
									localidadesDestinoSelecionadaList.addItemNovo(parada);
									break;
								}
							}
						}
						localidadesDestinoList.removeItem(parada);
					}
				}
			}));

			lsParadas = new HashSet<Parada>(0);
			ruta = cmbRutaOrigem.getSelectedItem() != null ? (Ruta) cmbRutaOrigem.getSelectedItem().getValue() : null;
			ruta = rutaService.obtenerID(ruta.getRutaId());
			if (ruta != null && ruta.getRutaCombinacionList() != null) {
				for (RutaCombinacion rc : ruta.getRutaCombinacionList()) {
					if (rc.getTramo() != null) {
						lsParadas.add(rc.getTramo().getOrigem());
						lsParadas.add(rc.getTramo().getDestino());
					}
				}
			}
			
			ArrayList<Parada> paradasDuplicadas = new ArrayList<Parada>(lsParadas);
			paradasDuplicadas.retainAll(localidadesDestinoSelecionadaList.getListData());

			localidadesOrigenSelecionadaList.getListData().removeAll(paradasDuplicadas);
			localidadesDestinoSelecionadaList.getListData().removeAll(paradasDuplicadas);

			localidadesComunsList.setModel(new ListModelList(paradasDuplicadas));
			lsLocalidadesComuns = paradasDuplicadas;

		} catch (Exception e) {
			log.error("", e);
		}

	}

	public void onSelect$cmbRutaOrigem(Event ev) throws Exception {
		executarPesquisaLocalidadesOrigen();
	}

	public void onSelect$cmbRutaDestino(Event ev) throws Exception {
		executarPesquisaLocalidadesDestino();
	}

	public void onClick$btnCombinarTrechos(Event ev) throws InterruptedException {
		if (lsLocalidadesComuns == null || lsLocalidadesComuns.isEmpty()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.selecionarConexion"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
		if(!validarTrechos() ) {
			return;
		}
		gerarCombinacao();
	}
	
	private boolean validarItensSalvar() throws InterruptedException {
		

		if (localidadesCombinadasList.getListData().isEmpty()) {
			Messagebox.show(Labels.getLabel("editarConexionPorRutaController.MSG.selecionarConexion"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return false;
		}
		
		txtTiempoMax.getValue();
		txtTiempoMin.getValue();
		
		return true;
	}


	public void onClick$btnNovoCanalVenta(Event ev) throws InterruptedException {
		
		if(cmbTipoPtovta.getSelectedItem() == null){
			return;
		}
		TipoPuntoVenta ptovta = (TipoPuntoVenta) cmbTipoPtovta.getSelectedItem().getValue();
		
		if (listEspCanal.getListData().contains(ptovta)) {
			Messagebox.show(
					Labels.getLabel("editarPricingEspecificoOcupacionController.MSG.noPricingEspecificoCanalJaCadastrado"),
					Labels.getLabel("busquedaPricingEspecificoController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else {
			if(ptovta.getTipoptovtaId() == -1){
				listEspCanal.clear();
			}else {
				@SuppressWarnings("unchecked")
				List<TipoPuntoVenta> canaisVenta = listEspCanal.getListData();
				for (TipoPuntoVenta tipoPuntoVenta : canaisVenta) {
					if(tipoPuntoVenta.getTipoptovtaId() == -1){
						listEspCanal.clear();
						listEspCanal.addItemNovo(tipoPuntoVenta);
						ptovta = null;
						break;
					}
				}
			}
			if(ptovta != null) {
				listEspCanal.addItemNovo(ptovta);
			}
			
		}
		
		cmbTipoPtovta.setValue("");
	}
	
	public void onClick$btnApagarCanalVenta(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarConexionPergunta"),
				Labels.getLabel("editarConexionExcepcionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (listEspCanal.getSelected() != null) {
				listEspCanal.removeItem((TipoPuntoVenta) listEspCanal.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.selecionarConexion"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}
	
	public void onClick$btnNovoPuntoVenta(Event ev) throws InterruptedException {
		
		if(cmbPtovta.getSelectedItem() == null){
			return;
		}
		PuntoVenta puntoVenta = (PuntoVenta) cmbPtovta.getSelectedItem().getValue();
		
		if (listPuntoVenta.getListData().contains(puntoVenta)) {
			Messagebox.show(
					Labels.getLabel("editarConexionPorRutaController.MSG.noPuntoVentaJaCadastrado"),
					Labels.getLabel("editarConexionPorRutaController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		} else {
			if(puntoVenta.getPuntoventaId() == -1){
				listPuntoVenta.clear();
			}else {
				@SuppressWarnings("unchecked")
				List<PuntoVenta> canaisVenta = listPuntoVenta.getListData();
				for (PuntoVenta puntoVentaAux : canaisVenta) {
					if(puntoVentaAux.getPuntoventaId() == -1){
						listPuntoVenta.clear();
						listPuntoVenta.addItemNovo(puntoVentaAux);
						puntoVenta = null;
						break;
					}
				}
			}
			if(puntoVenta != null) {
				listPuntoVenta.addItemNovo(puntoVenta);
			}
			
		}
		
		cmbTipoPtovta.setValue("");
	}
	
	public void onClick$btnApagarPuntoVenta(Event ev) throws InterruptedException {

		int resp = Messagebox.show(
				Labels.getLabel("editarConexionExcepcionController.MSG.borrarPuntoVentaPergunta"),
				Labels.getLabel("editarConexionPorRutaController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			if (listPuntoVenta.getSelected() != null) {
				listPuntoVenta.removeItem((PuntoVenta) listPuntoVenta.getSelectedItem().getValue());
			} else {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.selecionarConexion"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}
	}

	public List<Ruta> getLsRutas() {
		return lsRutas;
	}

	public void setLsRutas(List<Ruta> lsRutas) {
		this.lsRutas = lsRutas;
	}
	/**
	 * @return the lsPtovata
	 */
	public List<TipoPuntoVenta> getLsTipoPtovta() {
		return lsTipoPtovta;
	}

	/**
	 * @param lsPtovata
	 *            the lsPtovata to set
	 */
	public void setLsPtovata(List<TipoPuntoVenta> lsTipoPtovta) {
		this.lsTipoPtovta = lsTipoPtovta;
	}
	
	private void mostraMensagem(String msg) throws InterruptedException {
		Messagebox.show(msg, Labels.getLabel("editarConexionController.window.title"), Messagebox.OK, Messagebox.INFORMATION);
	}

	public List<Parada> getLsLocalidadesComuns() {
		return lsLocalidadesComuns;
	}

	public void setLsLocalidadesComuns(List<Parada> lsLocalidadesComuns) {
		this.lsLocalidadesComuns = lsLocalidadesComuns;
	}

	@SuppressWarnings("unchecked")
	private void gerarCombinacao() {

		List<Parada> listParada1 = localidadesOrigenSelecionadaList.getListData();

		for (int i = 0; i < getLsLocalidadesComuns().size(); i++) {

			List<Parada> listParada2 = getLsLocalidadesComuns();
			List<Parada> listParada3 = Arrays.asList(getLsLocalidadesComuns().get(i));
			List<Parada> listParada4 = localidadesDestinoSelecionadaList.getListData();

			LinkedList<List<Parada>> lists = new LinkedList<List<Parada>>();

			lists.add(listParada1);
			lists.add(listParada2);
			lists.add(listParada3);
			lists.add(listParada4);

			List<Parada> localidades = new ArrayList<Parada>();
			localidades.addAll(listParada1);
			localidades.addAll(listParada2);
			localidades.addAll(listParada3);
			localidades.addAll(listParada4);

			cacheLocalidades = criandoCacheLocalidades(localidades);
			gerarCombinacao(lists);

		}
	}

	public Map<Integer, Parada> criandoCacheLocalidades(List<Parada> list) {
		Map<Integer, Parada> map = new HashMap<Integer, Parada>();
		for (Parada parada : list) {
			map.put(parada.getParadaId(), parada);
		}
		return map;
	}

	private void gerarCombinacao(LinkedList<List<Parada>> lists) {

		List<ParadaVOConexionRuta> lsLocalidades = new ArrayList<ParadaVOConexionRuta>();

		Set<String> combinations = new TreeSet<String>();
		Set<String> newCombinations;

		for (Parada s : lists.removeFirst())
			combinations.add(s.getParadaId().toString());

		while (!lists.isEmpty()) {
			List<Parada> next = lists.removeFirst();
			newCombinations = new TreeSet<String>();
			for (String s1 : combinations)
				for (Parada s2 : next) {
					newCombinations.add(s1 + ";" + s2.getParadaId());
				}

			combinations = newCombinations;
		}
		
		String[] valoresCalculados = new String[3];
		short i = 1;
		Ruta rutaOrigem = (Ruta) cmbRutaOrigem.getSelectedItem().getValue();
		Ruta rutaDestino = (Ruta) cmbRutaDestino.getSelectedItem().getValue();
		conexoesCtrl = new ArrayList<ConexionCtrl>();
		
		for (String comb : combinations) {

			valoresCalculados = comb.split(";");
			lsLocalidades.add(new ParadaVOConexionRuta(cacheLocalidades.get(Integer.parseInt(valoresCalculados[0])), cacheLocalidades.get(Integer.parseInt(valoresCalculados[1])),rutaOrigem.getRutaId(),i, true,
					cacheLocalidades.get(Integer.parseInt(valoresCalculados[0])), cacheLocalidades.get(Integer.parseInt(valoresCalculados[3]))));
			i++;
			lsLocalidades.add(new ParadaVOConexionRuta(cacheLocalidades.get(Integer.parseInt(valoresCalculados[2])), cacheLocalidades.get(Integer.parseInt(valoresCalculados[3])), rutaDestino.getRutaId() ,i, true,
					cacheLocalidades.get(Integer.parseInt(valoresCalculados[0])), cacheLocalidades.get(Integer.parseInt(valoresCalculados[3]))));
			conexoesCtrl.add(new ConexionCtrl(cacheLocalidades.get(Integer.parseInt(valoresCalculados[0])).getParadaId(), cacheLocalidades.get(Integer.parseInt(valoresCalculados[3])).getParadaId()));
			i = 1;
		}

		localidadesCombinadasList.setData(lsLocalidades);
		localidadesCombinadasList.setItemRenderer(new RenderConexionPorRuta());

		for (ParadaVOConexionRuta localidade : lsLocalidades) {
			log.info(localidade);
		}
		
		resultadoCombinacao.setSelected(true);
		btnSalvar.setDisabled(Boolean.FALSE);
	}

	private boolean validarLinhaJaSelecionada() {
		if (cmbRutaOrigem.getSelectedItem() != null && cmbRutaDestino.getSelectedItem() != null) {
			if (cmbRutaOrigem.getSelectedItem().getValue().equals(cmbRutaDestino.getSelectedItem().getValue())) {
				return false;
			}
		}
		return true;
	}

}
